=== src/astar/src/CMakeLists.txt ===
ADD_LIBRARY(astar OBJECT
    astar.c
    astar_boost_wrapper.cpp)
