=== src/bd_astar/src/CMakeLists.txt ===
add_library(bd_astar OBJECT 
    bdastar.c 
    MinHeap.cpp 
    bdastar_core.cpp BiDirAStar.cpp)
