=== src/bd_dijkstra/src/CMakeLists.txt ===
ADD_LIBRARY(bd_dijkstra OBJECT 
    bdsp.c 
    bdsp_core.cpp 
    BiDirDijkstra.cpp)
