=== src/driving_distance/src/CMakeLists.txt ===
ADD_LIBRARY(driving_distance OBJECT
    drivedist.c
    many_to_dist_driving_distance.c
    boost_interface_drivedist.cpp

    withPoints_dd.c
    many_to_dist_withPointsDD.c
    withPoints_dd_driver.cpp
 )
