=== src/kdijkstra/src/CMakeLists.txt ===
ADD_LIBRARY(kdijkstra OBJECT 
    k_targets_boost_wrapper.cpp  
    k_targets_sp.c)
