=== debian/changelog ===
pgrouting (2.2.4-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update copyright file, changes:
    - Change Source URL to GitHub
    - Fix Upstream-Name capitalization
  * Drop override for debian-watch-may-check-gpg-signature.
  * Drop vrp_basic-include-math.patch, applied upstream.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 10 Aug 2016 00:56:59 +0200

pgrouting (2.2.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Drop references from PostLBS from package description.
  * Add patch to fix vrp_basic build failure (include math.h for ceil).

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 16 May 2016 11:46:05 +0200

pgrouting (2.2.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 29 Apr 2016 12:52:15 +0200

pgrouting (2.2.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Drop spelling-errors.patch, applied upstream.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 19 Apr 2016 09:01:34 +0200

pgrouting (2.2.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update copyright file, changes:
    - Update copyright years for various copyright holders
    - Add license & copyright for sources by Razequl Islam
    - Add new files by Alexander Neundorf
    - Add license & copyright for CMake files by Kitware, Inc
  * Bump Standards-Version to 3.9.8, no changes.
  * Simplify file glob patterns in doc-base.
  * Enable verbose make output.
  * Add patch to fix spelling errors.
  * Enable all hardening buildflags.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 08 Apr 2016 01:20:10 +0200
