=== debian/control ===
Source: pgrouting
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Michael Fladischer <FladischerMichael@fladi.at>
Section: misc
Priority: optional
Build-Depends: cmake,
               debhelper (>= 9),
               libboost-graph-dev,
               libcgal-dev,
               libjs-mathjax,
               postgresql-server-dev-all,
               python-sphinx (>= 1.0.7+dfsg)
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-grass/pgrouting.git
Vcs-Git: https://anonscm.debian.org/git/pkg-grass/pgrouting.git
Homepage: http://www.pgrouting.org

Package: postgresql-9.5-pgrouting
Architecture: any
Depends: postgresql-9.5,
         postgresql-9.5-postgis-2.2,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: postgresql-9.5-pgrouting-doc
Description: Routing functionality support for PostgreSQL/PostGIS
 pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
 geospatial routing and other network analysis functionality.
 .
 This package supports PostgreSQL 9.5.

Package: postgresql-9.5-pgrouting-doc
Architecture: all
Section: doc
Depends: libjs-mathjax,
         ${misc:Depends},
         ${sphinxdoc:Depends}
Description: Routing functionality support for PostgreSQL/PostGIS (Documentation)
 pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
 geospatial routing and other network analysis functionality.
 .
 This package contains the documentation.
