=== src/CMakeLists.txt ===
--- 
+++ 
@@ -55,5 +55,8 @@
 #ADD_SUBDIRECTORY(shooting_star)
 #LIST(APPEND L_PACKAGE_SQL_FILES "${PACKAGE_SQL_FILES}")
 
+#ADD_SUBDIRECTORY(contraction)
+#LIST(APPEND L_PACKAGE_SQL_FILES "${PACKAGE_SQL_FILES}")
+
 # Make sure this is after all the ADD_SUBDIRECTORY
 SET(PACKAGE_SQL_FILES "${L_PACKAGE_SQL_FILES}" PARENT_SCOPE)
