=== src/allpairs/sql/CMakeLists.txt ===
# Append in local scope
LIST(APPEND PACKAGE_SQL_FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/johnson.sql
    ${CMAKE_CURRENT_SOURCE_DIR}/floydWarshall.sql
    )

# set in parent scope
SET(PACKAGE_SQL_FILES "${PACKAGE_SQL_FILES}" PARENT_SCOPE)
