=== debian/changelog ===
pgrouting (2.3.0-1.pgdg+1) sid-pgdg; urgency=medium

  * Rebuild for sid-pgdg (jenkins-pgrouting-source-distribution=sid-11,
    b231bcbf092b5a66765557ac2c4c25399a8affd4/git)

 -- apt.postgresql.org autobuilder <pgsql-pkg-debian@postgresql.org>  Wed, 28 Sep 2016 22:18:28 +0200

pgrouting (2.3.0-1) unstable; urgency=medium

  * Team upload.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 26 Sep 2016 22:04:24 +0200

pgrouting (2.3.0-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * Drop exception-typo.patch, fixed upstream. Refresh remaining patch.
  * Update copyright file, changes:
    - Add additional copyright holders
    - Add license & copyright for fix_typos.sh
    - Drop license & copyright for shooting_star, removed upstream
  * Update Files & Index for doc-base registration.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 26 Sep 2016 18:36:41 +0200

pgrouting (2.2.4-2~exp1) experimental; urgency=medium

  * Team upload.
  * Update packaging for postgresql 9.6 & postgis 2.3.
  * Add patch to fix 'exception' typo.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 25 Sep 2016 16:19:07 +0200
