=== debian/control ===
--- 
+++ 
@@ -15,20 +15,20 @@
 Vcs-Git: https://anonscm.debian.org/git/pkg-grass/pgrouting.git
 Homepage: http://www.pgrouting.org
 
-Package: postgresql-9.5-pgrouting
+Package: postgresql-9.6-pgrouting
 Architecture: any
-Depends: postgresql-9.5,
-         postgresql-9.5-postgis-2.2,
+Depends: postgresql-9.6,
+         postgresql-9.6-postgis-2.3,
          ${misc:Depends},
          ${shlibs:Depends}
-Suggests: postgresql-9.5-pgrouting-doc
+Suggests: postgresql-9.6-pgrouting-doc
 Description: Routing functionality support for PostgreSQL/PostGIS
  pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
  geospatial routing and other network analysis functionality.
  .
- This package supports PostgreSQL 9.5.
+ This package supports PostgreSQL 9.6.
 
-Package: postgresql-9.5-pgrouting-doc
+Package: postgresql-9.6-pgrouting-doc
 Architecture: all
 Section: doc
 Depends: libjs-mathjax,
