=== debian/rules ===
--- 
+++ 
@@ -55,7 +55,7 @@
 	dh_install --list-missing
 
 override_dh_installchangelogs:
-	dh_installchangelogs doc/src/changelog/2_2_4.rst
+	dh_installchangelogs doc/src/changelog/release_notes.rst
 
 override_dh_makeshlibs:
 	dh_makeshlibs -Xusr/lib/postgresql
